/// <reference types="node" />
import { EventEmitter } from 'events';
export declare class IterableEventQueue extends EventEmitter {
    resolveNext: Function;
    queue: any[];
    hasDataListeners: boolean;
    [Symbol.asyncIterator](): EventQueueIterator;
    push(message: any): void;
    send(message: any): void;
    getNextMessage(): any;
    on(event_name: any, listener: any): this;
}
declare class EventQueueIterator {
    queue: IterableEventQueue;
    push(message: any): void;
    next(): Promise<unknown> | {
        value: any;
    };
    return(value: any): {
        value: any;
        done: boolean;
    };
    throw(error: any): {
        done: boolean;
    };
}
export {};
