import { Resource } from './Resource';
/**
 * This is the global set of all resources that have been registered on this server.
 */
export declare class Resources extends Map<string, typeof Resource> {
    isWorker: boolean;
    loginPath?: (request: any) => string;
    set(path: any, resource: any, type?: string, force?: boolean): void;
    /**
     * Find the best (longest) match resource path that matches the (beginning of the) provided path, in order to find
     * the correct Resource to handle this URL path.
     * @param path The URL Path
     * @param type Optional request content type, allows layering of resources, specifically for defining HTML handlers
     * that can further transform data from the main structured object resources.
     * @return The matched Resource class. Note that the remaining path is "returned" by setting the relativeURL property
     */
    getMatch(url: string, type?: string): any;
    getResource(path: string, resource_info: any): any;
    call(path: string, request: any, callback: Function): Promise<any>;
    setRepresentation(path: any, type: any, representation: any): void;
}
export declare let resources: Resources;
export declare function resetResources(): Resources;
export declare function keyArrayToString(key: any): any;
